﻿using System;
using System.Collections.ObjectModel;

using callfdk;

namespace test
{
	class TestMain
	{
		static void Main(string[] args)
		{
			try {
				CCallFdk.Initialize("callfdk.cfg");

				CallfdkTest();
			} catch (CMsgException e) {
				Console.WriteLine("Error: " + e.Message);
			}
			Console.WriteLine("Press any key ...");
			Console.ReadKey();
		}

		static void CallfdkTest()
		{
			M_IrNoteVanilla mIn = new M_IrNoteVanilla();

			mIn.mIrNotionalInfo = new M_IrNotionalInfo();
			mIn.mIrNotionalInfo.dNotionAmt = 10000.0;
			mIn.mIrNotionalInfo.sCcy = "KRW";

			mIn.mIrNotionalInfo.maIrAmortSchedule = new ObservableCollection<M_IrAmortSchedule>();
			M_IrAmortSchedule pAmort = new M_IrAmortSchedule();
			pAmort.iPeriodNo = 7;
			pAmort.dAmortAmt = 3000.0;
			mIn.mIrNotionalInfo.maIrAmortSchedule.Add(pAmort);
			pAmort = new M_IrAmortSchedule();
			pAmort.iPeriodNo = 8;
			pAmort.dAmortAmt = 7000.0;
			mIn.mIrNotionalInfo.maIrAmortSchedule.Add(pAmort);

			mIn.mIrNotionalInfo.iDisCrvId = 1;

			mIn.mIrVanilla = new M_IrVanilla();
			mIn.mIrVanilla.sPayRcvSect = "P";
			mIn.mIrVanilla.sPayTmPtC = "R";
			mIn.mIrVanilla.iFixedPeriodNo = 1;
			mIn.mIrVanilla.dFixedRate = 0.03;
			mIn.mIrVanilla.sDayCntConv = "A365";

			mIn.mIrVanilla.maIrCpnSchedule = new ObservableCollection<M_IrCpnSchedule>();
			M_IrCpnSchedule pSch = new M_IrCpnSchedule();
			pSch.iPeriodNo = 1;
			pSch.nFormerDate = "20150625";
			pSch.nAfterDate = "20150925";
			pSch.nCashflowDate = "20150925";
			mIn.mIrVanilla.maIrCpnSchedule.Add(pSch);

			pSch = new M_IrCpnSchedule();
			pSch.iPeriodNo = 2;
			pSch.nFormerDate = "20150925";
			pSch.nAfterDate = "20151225";
			pSch.nCashflowDate = "20151225";
			mIn.mIrVanilla.maIrCpnSchedule.Add(pSch);

			pSch = new M_IrCpnSchedule();
			pSch.iPeriodNo = 3;
			pSch.nFormerDate = "20151225";
			pSch.nAfterDate = "20160325";
			pSch.nCashflowDate = "20160325";
			mIn.mIrVanilla.maIrCpnSchedule.Add(pSch);

			pSch = new M_IrCpnSchedule();
			pSch.iPeriodNo = 4;
			pSch.nFormerDate = "20160325";
			pSch.nAfterDate = "20160625";
			pSch.nCashflowDate = "20160625";
			mIn.mIrVanilla.maIrCpnSchedule.Add(pSch);

			pSch = new M_IrCpnSchedule();
			pSch.iPeriodNo = 5;
			pSch.nFormerDate = "20160625";
			pSch.nAfterDate = "20160925";
			pSch.nCashflowDate = "20160925";
			mIn.mIrVanilla.maIrCpnSchedule.Add(pSch);

			pSch = new M_IrCpnSchedule();
			pSch.iPeriodNo = 6;
			pSch.nFormerDate = "20160925";
			pSch.nAfterDate = "20161225";
			pSch.nCashflowDate = "20161225";
			mIn.mIrVanilla.maIrCpnSchedule.Add(pSch);

			pSch = new M_IrCpnSchedule();
			pSch.iPeriodNo = 7;
			pSch.nFormerDate = "20160925";
			pSch.nAfterDate = "20170325";
			pSch.nCashflowDate = "20170325";
			mIn.mIrVanilla.maIrCpnSchedule.Add(pSch);

			pSch = new M_IrCpnSchedule();
			pSch.iPeriodNo = 8;
			pSch.nFormerDate = "20170325";
			pSch.nAfterDate = "20170625";
			pSch.nCashflowDate = "20170625";
			mIn.mIrVanilla.maIrCpnSchedule.Add(pSch);


			mIn.mIrVanilla.mIrVanillaCpn = new M_IrVanillaCpn();
			mIn.mIrVanilla.mIrVanillaCpn.mFdkRateIndexB = new M_FdkRateIndexB();
			M_FdkRateIndexB p = mIn.mIrVanilla.mIrVanillaCpn.mFdkRateIndexB;
			p.sRateIndexCode = "CD91D";
			p.sCcy = "KRW";
			p.sRateType = "S";
			p.sRateMatur = "91D";
			p.sCmpndFreq3 = "I";
			p.sDayCntConv = "A365";
			p.iRateCrvId = 1;
			p.dGearing = 1.0;
			mIn.mIrVanilla.mIrVanillaCpn.dMargin = 0.0;
			mIn.mIrVanilla.mIrVanillaCpn.sDayCntConv = "A365";

			mIn.mIrVanilla.maIrVanillaMon = new ObservableCollection<M_IrVanillaMon>();
			M_IrVanillaMon pMon = new M_IrVanillaMon();
			pMon.iPeriodNo = 2;
			pMon.bCouponFixingYN = true;
			pMon.dCouponRate = 0.023;
			mIn.mIrVanilla.maIrVanillaMon.Add(pMon);


			// Parameter setting
			mIn.mIrParam = new M_IrParam();
			mIn.mIrParam.maFdkRateCrvB = new ObservableCollection<M_FdkRateCurveB>();
			M_FdkRateCurveB pCrv = new M_FdkRateCurveB();
			pCrv.iRateCrvId = 1;
			pCrv.sCcy = "KRW";
			pCrv.sInterpMethod = "L";

			pCrv.maRateCrvTenor = new ObservableCollection<M_RateCurveTenor>();
			M_RateCurveTenor pTnr = new M_RateCurveTenor();
			pTnr.sRateType = "S";
			pTnr.dRate = 0.0223;
			pTnr.mTivMatur = new M_Tiv();
			pTnr.mTivMatur.sDateType = "S";
			pTnr.mTivMatur.sMatur = "1D";
			pTnr.sCmpndFreq3 = "I";
			pTnr.sDayCntConv = "ACTB";
			pCrv.maRateCrvTenor.Add(pTnr);

			pTnr = new M_RateCurveTenor();
			pTnr.sRateType = "Y";
			pTnr.dRate = 0.0235;
			pTnr.mTivMatur = new M_Tiv();
			pTnr.mTivMatur.sDateType = "S";
			pTnr.mTivMatur.sMatur = "3M";
			pTnr.sCmpndFreq3 = "Q";
			pTnr.sDayCntConv = "A365";
			pCrv.maRateCrvTenor.Add(pTnr);

			pTnr = new M_RateCurveTenor();
			pTnr.sRateType = "Y";
			pTnr.dRate = 0.022775;
			pTnr.mTivMatur = new M_Tiv();
			pTnr.mTivMatur.sDateType = "S";
			pTnr.mTivMatur.sMatur = "6M";
			pTnr.sCmpndFreq3 = "Q";
			pTnr.sDayCntConv = "A365";
			pCrv.maRateCrvTenor.Add(pTnr);

			pTnr = new M_RateCurveTenor();
			pTnr.sRateType = "Y";
			pTnr.dRate = 0.022575;
			pTnr.mTivMatur = new M_Tiv();
			pTnr.mTivMatur.sDateType = "S";
			pTnr.mTivMatur.sMatur = "9M";
			pTnr.sCmpndFreq3 = "Q";
			pTnr.sDayCntConv = "A365";
			pCrv.maRateCrvTenor.Add(pTnr);


			pCrv.maFwdCrvTenor = new ObservableCollection<M_FwdCurveTenor>();
			M_FwdCurveTenor pFwd = new M_FwdCurveTenor();
			pFwd.dRate = 0.027;
			pFwd.nFwdEndDate = "20160126";
			pFwd.sMatur = "3M";
			pFwd.sCmpndFreq3 = "I";
			pFwd.sDayCntConv = "A365";
			pCrv.maFwdCrvTenor.Add(pFwd);

			pFwd = new M_FwdCurveTenor();
			pFwd.dRate = 0.029;
			pFwd.nFwdEndDate = "20160226";
			pFwd.sMatur = "3M";
			pFwd.sCmpndFreq3 = "I";
			pFwd.sDayCntConv = "A365";
			pCrv.maFwdCrvTenor.Add(pFwd);


			pCrv.maRateCrvTenor2 = new ObservableCollection<M_RateCurveTenor>();
			pTnr = new M_RateCurveTenor();
			pTnr.sRateType = "Y";
			pTnr.dRate = 0.022375;
			pTnr.mTivMatur = new M_Tiv();
			pTnr.mTivMatur.sDateType = "S";
			pTnr.mTivMatur.sMatur = "1Y";
			pTnr.sCmpndFreq3 = "Q";
			pTnr.sDayCntConv = "A365";
			pCrv.maRateCrvTenor2.Add(pTnr);

			pTnr = new M_RateCurveTenor();
			pTnr.sRateType = "Y";
			pTnr.dRate = 0.022725;
			pTnr.mTivMatur = new M_Tiv();
			pTnr.mTivMatur.sDateType = "S";
			pTnr.mTivMatur.sMatur = "2Y";
			pTnr.sCmpndFreq3 = "Q";
			pTnr.sDayCntConv = "A365";
			pCrv.maRateCrvTenor2.Add(pTnr);

			pTnr = new M_RateCurveTenor();
			pTnr.sRateType = "Y";
			pTnr.dRate = 0.02305;
			pTnr.mTivMatur = new M_Tiv();
			pTnr.mTivMatur.sDateType = "S";
			pTnr.mTivMatur.sMatur = "2Y6M";
			pTnr.sCmpndFreq3 = "Q";
			pTnr.sDayCntConv = "A365";
			pCrv.maRateCrvTenor2.Add(pTnr);

			pTnr = new M_RateCurveTenor();
			pTnr.sRateType = "Y";
			pTnr.dRate = 0.023375;
			pTnr.mTivMatur = new M_Tiv();
			pTnr.mTivMatur.sDateType = "S";
			pTnr.mTivMatur.sMatur = "3Y";
			pTnr.sCmpndFreq3 = "Q";
			pTnr.sDayCntConv = "A365";
			pCrv.maRateCrvTenor2.Add(pTnr);

			pTnr = new M_RateCurveTenor();
			pTnr.sRateType = "Y";
			pTnr.dRate = 0.024725;
			pTnr.mTivMatur = new M_Tiv();
			pTnr.mTivMatur.sDateType = "S";
			pTnr.mTivMatur.sMatur = "5Y";
			pTnr.sCmpndFreq3 = "Q";
			pTnr.sDayCntConv = "A365";
			pCrv.maRateCrvTenor2.Add(pTnr);

			pTnr = new M_RateCurveTenor();
			pTnr.sRateType = "Y";
			pTnr.dRate = 0.02575;
			pTnr.mTivMatur = new M_Tiv();
			pTnr.mTivMatur.sDateType = "S";
			pTnr.mTivMatur.sMatur = "7Y";
			pTnr.sCmpndFreq3 = "Q";
			pTnr.sDayCntConv = "A365";
			pCrv.maRateCrvTenor2.Add(pTnr);

			pTnr = new M_RateCurveTenor();
			pTnr.sRateType = "Y";
			pTnr.dRate = 0.02705;
			pTnr.mTivMatur = new M_Tiv();
			pTnr.mTivMatur.sDateType = "S";
			pTnr.mTivMatur.sMatur = "10Y";
			pTnr.sCmpndFreq3 = "Q";
			pTnr.sDayCntConv = "A365";
			pCrv.maRateCrvTenor2.Add(pTnr);

			mIn.mIrParam.maFdkRateCrvB.Add(pCrv);

			mIn.mIrParam.nCalcDate = "20150625";

			mIn.mIrEffSensTreeParam = new M_IrEffSensTreeParam();
			mIn.mIrEffSensTreeParam.bDeltaYN = false;
			mIn.mIrEffSensTreeParam.sRDeltaType = "RP";
			mIn.mIrEffSensTreeParam.bVegaYN = false;
			mIn.mIrEffSensTreeParam.bFxVegaYN = false;
			mIn.mIrEffSensTreeParam.bThetaYN = true;
			mIn.mIrEffSensTreeParam.bReCalibYN = true;
			mIn.mIrEffSensTreeParam.bSpotDeltaYN = true;
			mIn.mIrEffSensTreeParam.bAccumDeltaYN = true;
			mIn.mIrEffSensTreeParam.sThetaType = "T";

			mIn.bDiffSensYN = true;

			M_IrNoteOut mOut = new M_IrNoteOut();
			CCallFdkError pError = CCallFdk.CallService(2106, mIn, mOut);
			if (pError != null) {
				Console.WriteLine("Error: " + pError.toString());
				return;
			} else {
				Console.WriteLine(mOut);
				Console.WriteLine("OK.");
			}
		}
	}
}